"""
Robot Class

Attributes:
     energy
     location
     name
     
Methods:
     up
     down
     left
     right
     attack

"""

class Robot(object):
    def __init__(self, name, x, y, energy):
        """ x,y coordinates: top left 0,0 """
        self.energy = energy
        self.x = x
        self.y = y
        self.name = name
        
    def __str__(self):
        return "{} at ({},{}) energy {}".format(self.name, self.x, self.y, self.energy)
    
    def up(self):
        if self.y >= 10:
            self.y -= 10
        self.energy += 1
        self.energy = min(self.energy,10)
        
    def down(self):
        if self.y <= 90:
            self.y += 10
        self.energy += 1
        self.energy = min(self.energy,10)    
        
    def left(self):
        if self.x >= 10:
            self.x -= 10
        self.energy += 1
        self.energy = min(self.energy,10)
        
    def right(self):
        if self.x <= 90:
            self.x += 10
        self.energy += 1
        self.energy = min(self.energy,10)            
        
    def attack(self):
        if self.energy > 3:
            self.energy -= 3
            return True
        else:
            return False
        
if __name__ == "__main__":
    
    name = input("Name => ")
    x = int(input("X location => "))
    y = int(input("Y location => "))
    energy = 10
    r = Robot(name, x,y, energy)
        
    cmd = (input("Command (stop to end) ==> ")).lower()
    print (r)
    while cmd != 'stop':
        if cmd == 'up':
            r.up()
        elif cmd == 'down':
            r.down()
        elif cmd == 'left':
            r.left()
        elif cmd == 'right':
            r.right()
        elif cmd == 'attack':
            if not r.attack():
                print ("Not enough energy!")
        else:
            print ("Not a valid command")
        print (r)
        cmd = (input("Command (stop to end) ==> ")).lower()
        
            